<?php
// 以下をそれぞれ表示してください。
// 表示するタイミングによって自動で算出すること
// ・現在日時（yyyy年mm月dd日 H時i分s秒）
// ・現在日時から3日後
// ・現在日時から12時間前
// ・2020年元旦から現在までの経過日数
// ・現在の西暦を和暦に変更して出力

// 日時がおかしい場合、PHPのタイムゾーン設定を行ってください
<?php
// タイムゾーンを設定（例：東京）
date_default_timezone_set('Asia/Tokyo');

// 現在日時（yyyy年mm月dd日 H時i分s秒）
echo "現在日時: " . date("Y年m月d日 H時i分s秒") . "\n";

// 現在日時から3日後
$threeDaysLater = date("Y-m-d H:i:s", strtotime("+3 days"));
echo "現在日時から3日後: " . $threeDaysLater . "\n";

// 現在日時から12時間前
$twelveHoursBefore = date("Y-m-d H:i:s", strtotime("-12 hours"));
echo "現在日時から12時間前: " . $twelveHoursBefore . "\n";

// 2020年元旦から現在までの経過日数
$startDate = new DateTime("2020-01-01");
$today = new DateTime("now");
$interval = $startDate->diff($today);
echo "2020年元旦から現在までの経過日数: " . $interval->days . "日\n";

// 現在の西暦を和暦に変更して出力
// 明治以降の和暦にのみ対応
function convertToJapaneseEra($date) {
    $year = (int)$date->format("Y");
    if ($year >= 2019) { // 令和
        $eraYear = $year - 2018;
        return "令和" . ($eraYear === 1 ? "元" : $eraYear) . "年";
    } elseif ($year >= 1989) { // 平成
        $eraYear = $year - 1988;
        return "平成" . ($eraYear === 1 ? "元" : $eraYear) . "年";
    } elseif ($year >= 1926) { // 昭和
        $eraYear = $year - 1925;
        return "昭和" . ($eraYear === 1 ? "元" : $eraYear) . "年";
    } elseif ($year >= 1912) { // 大正
        $eraYear = $year - 1911;
        return "大正" . ($eraYear === 1 ? "元" : $eraYear) . "年";
    } else { // 明治
        $eraYear = $year - 1867;
        return "明治" . ($eraYear === 1 ? "元" : $eraYear) . "年";
    }
}

echo "現在の西暦を和暦に変更: " . convertToJapaneseEra($today) . "\n";
?>
